// sample1Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "sample1.h"
#include "sample1Dlg.h"
#include "AIOUSB.h"
#include "DetectDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSample1Dlg dialog

CSample1Dlg::CSample1Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample1Dlg::IDD, pParent)
	, m_BaseRateHz(60.0)
	, m_DurationAms(.33)
	, m_DurationBms(.66)
	, m_DurationCms(.99)
	, m_BaseRateHz2(0)
	, m_DurationAms2(0)
	, m_DurationBms2(0)
	, m_DurationCms2(0)
{
	//{{AFX_DATA_INIT(CSample1Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample1Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSample1Dlg)
	//}}AFX_DATA_MAP
	DDX_Text(pDX, IDC_ED_FREQ, m_BaseRateHz);
	DDX_Text(pDX, IDC_ED_DURA, m_DurationAms);
	DDX_Text(pDX, IDC_ED_DURB, m_DurationBms);
	DDX_Text(pDX, IDC_ED_DURC, m_DurationCms);
	DDX_Text(pDX, IDC_ED_FREQ2, m_BaseRateHz2);
	DDX_Text(pDX, IDC_ED_DURA2, m_DurationAms2);
	DDX_Text(pDX, IDC_ED_DURB2, m_DurationBms2);
	DDX_Text(pDX, IDC_ED_DURC2, m_DurationCms2);
}

BEGIN_MESSAGE_MAP(CSample1Dlg, CDialog)
	//{{AFX_MSG_MAP(CSample1Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BTN_SYNC, &CSample1Dlg::OnBnClickedBtnSync)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSample1Dlg message handlers

BOOL CSample1Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	DetectDialog box;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	deviceIndex = diOnly;

	outMask = 0;
	if (DIO_Configure(deviceIndex, false, &outMask, data) != ERROR_SUCCESS)
	{
		box.DoModal();

		deviceIndex=box.index;

		if (deviceIndex == -1) //no valid device was selected
			exit(0);
	}
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample1Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample1Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSample1Dlg::OnBnClickedBtnSync()
{
	// Get the partameters and do the syncronization readback and display the results:
	int status;
	double Rate, DurA, DurB, DurC;

	UpdateData(true);
	Rate = m_BaseRateHz;
	DurA = m_DurationAms;
	DurB = m_DurationBms;
	DurC = m_DurationCms;

	status = DIO_CSA_DoSync(deviceIndex, &Rate, &DurA, &DurB, &DurC);

	m_BaseRateHz2 = Rate;
	m_DurationAms2 = DurA;
	m_DurationBms2 = DurB;
	m_DurationCms2 = DurC;
	UpdateData(false);
}
